package com.sundata.internalevaluation.configuration.controller;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import com.sundata.internalevaluation.configuration.model.SysInterfaceParam;
import com.sundata.internalevaluation.configuration.service.SysInterfaceParamService;

@RestController
@RequestMapping("/npapiparam")
public class SysInterfaceParamController {

    @Autowired
    private SysInterfaceParamService sysReqInterfaceParamService;

    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    @RequestMapping("list")
    public List<SysInterfaceParam> listAll() {
        return sysReqInterfaceParamService.listAll();
    }


    /**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
    @RequestMapping("getById")
    public SysInterfaceParam getById(String id) {
        return sysReqInterfaceParamService.getById(id);
    }    
     
    /**
     * 新增，忽略null字段
     *
     * @param sysReqInterfaceParam 新增的记录
     * @return 返回影响行数
     */
    @RequestMapping("insert")
    public int insert(@RequestBody SysInterfaceParam sysReqInterfaceParam) {
        return sysReqInterfaceParamService.insertIgnoreNull(sysReqInterfaceParam);
    }    
      
    /**
     * 修改，忽略null字段
     *
     * @param sysReqInterfaceParam 修改的记录
     * @return 返回影响行数
     */
    @RequestMapping("update")
    public int update(@RequestBody SysInterfaceParam sysReqInterfaceParam) {
        return sysReqInterfaceParamService.updateIgnoreNull(sysReqInterfaceParam);
    }
    
    /**
     * 删除记录
     *
     * @param sysReqInterfaceParam 待删除的记录
     * @return 返回影响行数
     */
    @RequestMapping("delete")
    public int delete(@RequestBody SysInterfaceParam sysReqInterfaceParam) {
        return sysReqInterfaceParamService.delete(sysReqInterfaceParam);
    }
    
}